
' PROGRAM Up7 
' (c) Starsoft 2023 Pascalated Boriel ZX BASIC
' Written by David Magalhaes
' Pascalated Sinclair BASIC (c) 1987 by ZarSoft
' Pascalated BASIC Converter (c) 2021 by Zarsoft
' Pascalated Boriel (c) 2023 by ZarSoft
' ZX BASIC Compiler (c) 2008 by Boriel

#include <input.bas>  ' number = VAL INPUT(12)
#include <screen.bas> ' SCREEN$ function
#include <attr.bas>   ' ATTR function

'--- Pascalated Boriel ---
#define PROGRAM   REM
#define BEGIN REM
'#define CONST     CONST
#define VAR       DIM
#define INTEGER   LONG
#define REAL      FLOAT
#define CHAR      STRING ' UBYTE is type integer
'#define STRING    STRING
#define BOOLEAN   UBYTE
#define TYPE      AS
#define BEGIN     REM
'#define WHILE    WHILE
#define REPEAT    DO
#define UNTIL     LOOP UNTIL
#define PROCEDURE  SUB
#define ORD        CODE
'#define MOD        MOD
CONST   TRUE      TYPE BOOLEAN = 1 
CONST   FALSE     TYPE BOOLEAN = 0 


PROGRAM Up7

' CONSTant declarations
CONST black = 0
CONST blue = 1
CONST red = 2
CONST magenta = 3
CONST green = 4
CONST cyan = 5
CONST yellow = 6
CONST white = 7
CONST npositions TYPE INTEGER = 9
CONST ncards TYPE INTEGER = 35

' VAR - Global variables
VAR Board(9) TYPE INTEGER ' Cards on table
VAR Deck1(7) TYPE INTEGER ' Player 1 available cards
VAR Deck2(7) TYPE INTEGER ' Player 2 available cards
VAR Score1 TYPE INTEGER ' Player 1 Score
VAR Score2 TYPE INTEGER ' Player 2 Score
VAR KEYMAP(128) TYPE INTEGER ' keyBoard to card number
VAR POSITION(10,3) TYPE INTEGER ' position and id of cards (lin, col, card)
VAR KEYS$ TYPE STRING ' keys to identify cards
VAR FirstPlayer TYPE INTEGER ' Player 1, Player 2
VAR Turn TYPE INTEGER ' Player 1, Player 2
VAR Card TYPE INTEGER ' selected card 1 to 7
VAR Dest TYPE INTEGER ' card destination position
VAR s$,t$,v$,w$ TYPE STRING ' card chars

'--- KEYBoard ---

VAR LASTKEY$ TYPE STRING = ""

PROCEDURE WaitKey
REPEAT
  PAUSE 0
  LASTKEY$ = INKEY$
UNTIL INKEY$ <> ""
RANDOMIZE
END PROCEDURE

FUNCTION LastKey$ TYPE STRING
RETURN LASTKEY$
END FUNCTION

'-------------------------

PROCEDURE PrintBack (p TYPE INTEGER)
PRINT AT POSITION(p,1)+0,POSITION(p,2);PAPER 4;INK 0;"\A\A\A\A\A";
PRINT AT POSITION(p,1)+1,POSITION(p,2);PAPER 4;INK 0;"\A\A\A\A\A";
PRINT AT POSITION(p,1)+2,POSITION(p,2);PAPER 4;INK 0;"\A\A\A\A\A";
PRINT AT POSITION(p,1)+3,POSITION(p,2);PAPER 4;INK 0;"\A\A\A\A\A";
PRINT AT POSITION(p,1)+4,POSITION(p,2);PAPER 4;INK 0;"\A\A\A\A\A";
PRINT AT POSITION(p,1)+5,POSITION(p,2);PAPER 4;INK 0;"\A\A\A\A\A";
PRINT AT POSITION(p,1)+6,POSITION(p,2);PAPER 4;INK 0;"\A\A\A\A\A";
END PROCEDURE

PROCEDURE PrintInitialBoard
VAR p TYPE INTEGER
PAPER 7: INK 2
FOR p=1 TO npositions
  PrintBack(p)
  BEEP .02,20*RND
NEXT p
END PROCEDURE

PROCEDURE PrintCard1 (p TYPE INTEGER)
PRINT AT POSITION(p,1)+0,POSITION(p,2);v$;"    ";
PRINT AT POSITION(p,1)+1,POSITION(p,2);"     ";
PRINT AT POSITION(p,1)+2,POSITION(p,2);"     ";
PRINT AT POSITION(p,1)+3,POSITION(p,2);"  "+s$+"  ";
PRINT AT POSITION(p,1)+4,POSITION(p,2);"     ";
PRINT AT POSITION(p,1)+5,POSITION(p,2);"     ";
PRINT AT POSITION(p,1)+6,POSITION(p,2);"    ";w$;
END PROCEDURE

PROCEDURE PrintCard2 (p TYPE INTEGER)
PRINT AT POSITION(p,1)+0,POSITION(p,2);v$;"    ";
PRINT AT POSITION(p,1)+1,POSITION(p,2);"  ";s$;"  ";
PRINT AT POSITION(p,1)+2,POSITION(p,2);"     ";
PRINT AT POSITION(p,1)+3,POSITION(p,2);"     ";
PRINT AT POSITION(p,1)+4,POSITION(p,2);"     ";
PRINT AT POSITION(p,1)+5,POSITION(p,2);"  ";t$;"  ";
PRINT AT POSITION(p,1)+6,POSITION(p,2);"    ";w$;
END PROCEDURE

PROCEDURE PrintCard3 (p TYPE INTEGER)
PRINT AT POSITION(p,1)+0,POSITION(p,2);v$;"    ";
PRINT AT POSITION(p,1)+1,POSITION(p,2);"  ";s$;"  ";
PRINT AT POSITION(p,1)+2,POSITION(p,2);"     ";
PRINT AT POSITION(p,1)+3,POSITION(p,2);"  ";s$;"  ";
PRINT AT POSITION(p,1)+4,POSITION(p,2);"     ";
PRINT AT POSITION(p,1)+5,POSITION(p,2);"  ";t$;"  ";
PRINT AT POSITION(p,1)+6,POSITION(p,2);"    ";w$;
END PROCEDURE

PROCEDURE PrintCard4 (p TYPE INTEGER)
PRINT AT POSITION(p,1)+0,POSITION(p,2);v$;"    ";
PRINT AT POSITION(p,1)+1,POSITION(p,2);" ";s$;" ";s$;" ";
PRINT AT POSITION(p,1)+2,POSITION(p,2);"     ";
PRINT AT POSITION(p,1)+3,POSITION(p,2);"     ";
PRINT AT POSITION(p,1)+4,POSITION(p,2);"     ";
PRINT AT POSITION(p,1)+5,POSITION(p,2);" ";t$;" ";t$;" ";
PRINT AT POSITION(p,1)+6,POSITION(p,2);"    ";w$;
END PROCEDURE

PROCEDURE PrintCard5 (p TYPE INTEGER)
PRINT AT POSITION(p,1)+0,POSITION(p,2);v$;"    ";
PRINT AT POSITION(p,1)+1,POSITION(p,2);" ";s$;" ";s$;" ";
PRINT AT POSITION(p,1)+2,POSITION(p,2);"     ";
PRINT AT POSITION(p,1)+3,POSITION(p,2);"  ";s$;"  ";
PRINT AT POSITION(p,1)+4,POSITION(p,2);"     ";
PRINT AT POSITION(p,1)+5,POSITION(p,2);" ";t$;" ";t$;" ";
PRINT AT POSITION(p,1)+6,POSITION(p,2);"    ";w$;
END PROCEDURE

PROCEDURE PrintCard6 (p TYPE INTEGER)
PRINT AT POSITION(p,1)+0,POSITION(p,2);v$;"    ";
PRINT AT POSITION(p,1)+1,POSITION(p,2);" ";s$;" ";s$;" ";
PRINT AT POSITION(p,1)+2,POSITION(p,2);"     ";
PRINT AT POSITION(p,1)+3,POSITION(p,2);" ";s$;" ";s$;" ";
PRINT AT POSITION(p,1)+4,POSITION(p,2);"     ";
PRINT AT POSITION(p,1)+5,POSITION(p,2);" ";t$;" ";t$;" ";
PRINT AT POSITION(p,1)+6,POSITION(p,2);"    ";w$;
END PROCEDURE

PROCEDURE PrintCard7 (p TYPE INTEGER)
PRINT AT POSITION(p,1)+0,POSITION(p,2);v$;"    ";
PRINT AT POSITION(p,1)+1,POSITION(p,2);" ";s$;" ";s$;" ";
PRINT AT POSITION(p,1)+2,POSITION(p,2);"  ";s$;"  ";
PRINT AT POSITION(p,1)+3,POSITION(p,2);" ";s$;" ";s$;" ";
PRINT AT POSITION(p,1)+4,POSITION(p,2);"     ";
PRINT AT POSITION(p,1)+5,POSITION(p,2);" ";t$;" ";t$;" ";
PRINT AT POSITION(p,1)+6,POSITION(p,2);"    ";w$;
pause 1*50
PRINT AT POSITION(p,1)+0,POSITION(p,2);"\A\A\A\A\A";
PRINT AT POSITION(p,1)+1,POSITION(p,2);"\A\A\A\A\A";
PRINT AT POSITION(p,1)+2,POSITION(p,2);"\A\A\A\A\A";
PRINT AT POSITION(p,1)+3,POSITION(p,2);"\A\A\A\A\A";
PRINT AT POSITION(p,1)+4,POSITION(p,2);"\A\A\A\A\A";
PRINT AT POSITION(p,1)+5,POSITION(p,2);"\A\A\A\A\A";
PRINT AT POSITION(p,1)+6,POSITION(p,2);"\A\A\A\A\A";
END PROCEDURE

PROCEDURE PrintCard (p TYPE INTEGER)
VAR suit TYPE INTEGER
VAR cor TYPE INTEGER
VAR value TYPE INTEGER
IF Turn = 1 THEN
  LET suit = Deck1(Card)
ELSE
  LET suit = Deck2(Card)
ENDIF
LET cor = Turn
LET value = Card
LET s$ = CHR$ ( CODE ("\I") - 1 + suit )
LET t$ = CHR$ ( CODE ("\N") - 1 + suit )
LET v$ = CHR$ ( CODE ("1") - 1 + value )
LET w$ = CHR$ ( CODE ("\B") - 1 + value )
INK cor
IF     value = 1 
  PrintCard1(p)
ELSEIF value = 2 
  PrintCard2(p)
ELSEIF value = 3 
  PrintCard3(p)
ELSEIF value = 4
  PrintCard4(p)
ELSEIF value = 5
  PrintCard5(p)
ELSEIF value = 6
  PrintCard6(p)
ELSEIF value = 7
  PrintCard7(p)
ENDIF
END PROCEDURE

PROCEDURE PrintDecks
VAR i TYPE INTEGER
VAR j TYPE INTEGER
VAR c TYPE STRING
PAPER 7
FOR i=1 TO 7
  FOR j=1 TO 5
    c = " "
    IF Deck1(i) >= j THEN c = STR$(i)
    PRINT AT 15+i,j-1; INK blue; c;
    c = " "
    IF Deck2(i) >= j THEN c = STR$(i)
    PRINT AT 15+i,30-(j-1); INK red; c;
  NEXT j
NEXT i
END PROCEDURE

PROCEDURE DealCards
VAR i TYPE INTEGER
FOR i=1 TO 9
  Board(i) = 0
NEXT i
FOR i=1 TO 7
  Deck1(i) = 5
  Deck2(i) = 5
NEXT i
END PROCEDURE

PROCEDURE UpdateScore
VAR spc TYPE STRING
spc = "" : IF Score1 < 10 THEN spc = " "
PRINT PAPER magenta; AT 4,0; INK black; "Wins:"; spc; INK white; Score1;
spc = "" : IF Score1 < 10 THEN spc = " "
PRINT PAPER magenta; AT 4,24; INK black; "Wins:"; spc; INK white; Score2;
END PROCEDURE

PROCEDURE PrintResult ' FirstPlayer 1 wins - FirstPlayer 2 wins
VAR i TYPE INTEGER
FOR i = 1 TO 20: BEEP .02,i: BEEP .02,20*RND: NEXT i
FOR i = 0 TO 6
  PRINT AT 8+i,7;PAPER yellow;" ";TAB 23;" ";
NEXT i  
' Attribution must be reversed because turn was already changed
IF Turn = 1 THEN
  Score2 = Score2 + 1
  'PRINT PAPER yellow; INK red; AT 11,10; " PLAYER 2 "; AT 12,12; " WINS! "
  ' ... .   ... . . ... ..    ...
  ' :.: :   :.: '.' :.. :.'   ..:
  ' :   :.. : :  :  :.. : :   :..
  '
  ' .   . ... .  . ...   .
  ' : . :  :  :'.: :..   :
  ' :' ': .:. :  : ..:   . 
  '
  PRINT PAPER yellow; INK red; AT  8, 8;"\..\. \. \  \..\. \. \. \..\. \..\. \  \..\. "
  PRINT PAPER yellow; INK red; AT  9, 8;"\:.\: \: \  \:.\: \'.\' \:.\. \:.\' \  \..\: "
  PRINT PAPER yellow; INK red; AT 10, 8;"\: \  \:.\. \: \: \ :\  \:.\. \: \: \  \:.\. "
  PRINT PAPER yellow; INK red; AT 11,10;"\. \  \. \..\. \. \ .\ .\..\  \ ."
  PRINT PAPER yellow; INK red; AT 12,10;"\: \. \: \ :\  \:'\.:\ :\..\  \ :"
  PRINT PAPER yellow; INK red; AT 13,10;"\:'\ '\: \.:\. \: \ :\ .\.:\  \ ."
ELSE
  Score1 = Score1 + 1
  'PRINT PAPER yellow; INK blue; AT 11,10; " PLAYER 1 "; AT 12,12; " WINS! "
  ' ... .   ... . . ... ..     .
  ' :.: :   :.: '.' :.. :.'   ':
  ' :   :.. : :  :  :.. : :   .:.
  '
  ' .   . ... .  . ...   .
  ' : . :  :  :'.: :..   :
  ' :' ': .:. :  : ..:   . 
  '
  PRINT PAPER yellow; INK blue; AT  8, 8;"\..\. \. \  \..\. \. \. \..\. \..\. \  \. "
  PRINT PAPER yellow; INK blue; AT  9, 8;"\:.\: \: \  \:.\: \'.\' \:.\. \:.\' \ '\: "
  PRINT PAPER yellow; INK blue; AT 10, 8;"\: \  \:.\. \: \: \ :\  \:.\. \: \: \ .\:."
  PRINT PAPER yellow; INK blue; AT 11,10;"\. \  \. \..\. \. \ .\ .\..\  \ ."
  PRINT PAPER yellow; INK blue; AT 12,10;"\: \. \: \ :\  \:'\.:\ :\..\  \ :"
  PRINT PAPER yellow; INK blue; AT 13,10;"\:'\ '\: \.:\. \: \ :\ .\.:\  \ ."
ENDIF
UpdateScore
PAUSE 3*50
END PROCEDURE

PROCEDURE PrintIndex
VAR p TYPE INTEGER
FOR p = 1 TO npositions
  PRINT AT POSITION(p,1)+6,POSITION(p,2)-1; PAPER 0; INK yellow;KEYS$(p);
NEXT p
END PROCEDURE

PROCEDURE InitGame
BORDER 0: PAPER black: INK white: CLS
FirstPlayer = 3 - FirstPlayer
Turn = FirstPlayer
PAPER magenta
PRINT AT 2,0; INK black; "Player"; INK white; "1"
PRINT AT 2,24; INK black; "Player"; INK white; "2"
UpdateScore
PrintInitialBoard
PrintIndex
DealCards
PrintDecks
END PROCEDURE

FUNCTION MovePossible TYPE BOOLEAN
VAR res TYPE BOOLEAN
VAR i TYPE INTEGER
res = FALSE
IF Turn = 1
  FOR i = 1 TO 9
    IF Board(i) = 0 THEN res = TRUE
    IF Board(i) < 7 THEN IF Deck1(Board(i)+1) > 0 THEN res = TRUE
  NEXT i
ELSE
  FOR i = 1 TO 9
    IF Board(i) = 0 THEN res = TRUE
    IF Board(i) < 7 THEN IF Deck2(Board(i)+1) > 0 THEN res = TRUE
  NEXT i
ENDIF
RETURN res
END FUNCTION

FUNCTION PlayerHasCard TYPE BOOLEAN
VAR res TYPE BOOLEAN
res = FALSE
IF Turn = 1 AND Deck1(Card) > 0
  res = TRUE
ELSEIF Turn = 2 AND Deck2(Card) > 0
  res = TRUE
ENDIF
RETURN res
END FUNCTION

PROCEDURE SelectMove
VAR col TYPE INTEGER
col = 0
IF Turn = 2 THEN col = 25
REPEAT
  REPEAT
    PRINT AT 10,col;PAPER 0; INK 7;FLASH 1;"FROM ?";AT 11,col;FLASH 0;"    "
    BEEP .02,0: BEEP .02,20*RND
    WaitKey: BEEP .1,20
    Card = 0
    IF LastKey$ >= "1" AND LastKey$ <= "7" THEN Card = VAL LastKey$
  UNTIL Card > 0 AND PlayerHasCard
  PRINT AT 10,col;PAPER 0; INK 7;FLASH 1;"FROM ";Card;AT 11,col;"TO ?"
  ' BEEP .02,0: BEEP .02,20*RND
  WaitKey: BEEP .1,20
  Dest = KEYMAP( CODE LastKey$)
UNTIL Dest > 0 AND ((Board(Dest) = 0 AND Card < 7) OR Card = Board(Dest) + 1)
PRINT AT 10,col;PAPER 0;FLASH 0;"      ";AT 11,col;"    "
END PROCEDURE

PROCEDURE NoMove
VAR col TYPE INTEGER
col = 0
IF Turn = 2 THEN col = 25
PRINT AT 10,col;PAPER 0; INK yellow;FLASH 1;"Cannot";AT 11,col;"Move! "
pause 2*50
PRINT AT 10,col;PAPER 0;FLASH 0;"      ";AT 11,col;"      "
END PROCEDURE

FUNCTION GameOver TYPE BOOLEAN
VAR res TYPE BOOLEAN
res = FALSE
IF Deck1(7) = 0 OR Deck2(7) = 0 THEN res = TRUE
RETURN res
END FUNCTION

PROCEDURE PlayCard
PrintCard(Dest)
IF Turn = 1 THEN
  PRINT AT 15+Card,Deck1(Card)-1; PAPER black; INK blue; " ";
  Deck1(Card) = Deck1(Card) - 1
ELSE
  PRINT AT 15+Card,30-(Deck2(Card)-1); PAPER black; INK red; " ";
  Deck2(Card) = Deck2(Card) - 1
ENDIF
Board(Dest) = Card
END PROCEDURE

PROCEDURE Game
InitGame
REPEAT
  IF MovePossible THEN
    SelectMove
    PlayCard
  ELSE
    NoMove
  ENDIF
  pause 1*50
  Turn = 3 - Turn
UNTIL GameOver 
PrintResult
END PROCEDURE

PROCEDURE DefineSprites
VAR i,n TYPE INTEGER
VAR b$ TYPE STRING
RESTORE ' DataChars
READ b$
REPEAT
  FOR i=0 TO 7
    READ n
    POKE USR b$+i,n
  NEXT i
  READ b$
UNTIL b$ = ""
END PROCEDURE

PROCEDURE DataSprites
DATA "A" : REM back of card
DATA BIN 10101010
DATA BIN 01010101
DATA BIN 10101010
DATA BIN 01010101
DATA BIN 10101010
DATA BIN 01010101
DATA BIN 10101010
DATA BIN 01010101
DATA "B" : REM upside down numbers
DATA BIN 00000000
DATA BIN 01111100
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 00010000
DATA BIN 00010100
DATA BIN 00011000
DATA BIN 00000000
DATA "C"
DATA BIN 00000000
DATA BIN 01111110
DATA BIN 00000010
DATA BIN 00111100
DATA BIN 01000000
DATA BIN 01000010
DATA BIN 00111100
DATA BIN 00000000
DATA "D"
DATA BIN 00000000
DATA BIN 00111100
DATA BIN 01000010
DATA BIN 01000000
DATA BIN 00110000
DATA BIN 01000010
DATA BIN 00111100
DATA BIN 00000000
DATA "E"
DATA BIN 00000000
DATA BIN 00010000
DATA BIN 01111110
DATA BIN 00010010
DATA BIN 00010100
DATA BIN 00011000
DATA BIN 00010000
DATA BIN 00000000
DATA "F"
DATA BIN 00000000
DATA BIN 00111100
DATA BIN 01000010
DATA BIN 01000000
DATA BIN 00111110
DATA BIN 00000010
DATA BIN 01111110
DATA BIN 00000000
DATA "G"
DATA BIN 00000000
DATA BIN 00111100
DATA BIN 01000010
DATA BIN 01000010
DATA BIN 00111110
DATA BIN 00000010
DATA BIN 00111100
DATA BIN 00000000
DATA "H"
DATA BIN 00000000
DATA BIN 00001000
DATA BIN 00001000
DATA BIN 00010000
DATA BIN 00100000
DATA BIN 01000000
DATA BIN 01111110
DATA BIN 00000000
DATA "I" : REM upright suit
DATA BIN 00000000
DATA BIN 11000011
DATA BIN 11100111
DATA BIN 01111110
DATA BIN 00111100
DATA BIN 00011000
DATA BIN 00011000
DATA BIN 00011000
DATA "J"
DATA BIN 00000000
DATA BIN 00001000
DATA BIN 00011100
DATA BIN 00111110
DATA BIN 01111111
DATA BIN 00111110
DATA BIN 00011100
DATA BIN 00001000
DATA "K"
DATA BIN 00000000
DATA BIN 01100011
DATA BIN 01110111
DATA BIN 00111110
DATA BIN 00011100
DATA BIN 00111110
DATA BIN 01110111
DATA BIN 01100011
DATA "L"
DATA BIN 00000000
DATA BIN 00111100
DATA BIN 01111110
DATA BIN 01111110
DATA BIN 01111110
DATA BIN 01111110
DATA BIN 00111100
DATA BIN 00000000
DATA "M"
DATA BIN 00000000
DATA BIN 00001000
DATA BIN 00011100
DATA BIN 00011100
DATA BIN 00111110
DATA BIN 00111110
DATA BIN 01111111
DATA BIN 01111111
DATA "N" : REM upside down suit
DATA BIN 00011000
DATA BIN 00011000
DATA BIN 00011000
DATA BIN 00111100
DATA BIN 01111110
DATA BIN 11100111
DATA BIN 11000011
DATA BIN 00000000
DATA "O"
DATA BIN 00010000
DATA BIN 00111000
DATA BIN 01111100
DATA BIN 11111110
DATA BIN 01111100
DATA BIN 00111000
DATA BIN 00010000
DATA BIN 00000000
DATA "P"
DATA BIN 11000110
DATA BIN 11101110
DATA BIN 01111100
DATA BIN 00111000
DATA BIN 01111100
DATA BIN 11101110
DATA BIN 11000110
DATA BIN 00000000
DATA "Q"
DATA BIN 00000000
DATA BIN 00111100
DATA BIN 01111110
DATA BIN 01111110
DATA BIN 01111110
DATA BIN 01111110
DATA BIN 00111100
DATA BIN 00000000
DATA "R"
DATA BIN 11111110
DATA BIN 11111110
DATA BIN 01111100
DATA BIN 01111100
DATA BIN 00111000
DATA BIN 00111000
DATA BIN 00010000
DATA BIN 00000000
DATA ""
END PROCEDURE

PROCEDURE InitProgram
VAR c TYPE INTEGER
VAR s TYPE INTEGER
VAR v TYPE INTEGER
DefineSprites
REM keyBoard index
POKE 23658,8: REM upper case
LET KEYS$="XQWEASDZXC"
REM keymap - keyBoard to card number
'DIM KEYMAP(128)
LET KEYMAP( CODE "Q")=1
LET KEYMAP( CODE "W")=2
LET KEYMAP( CODE "E")=3
LET KEYMAP( CODE "A")=4
LET KEYMAP( CODE "S")=5
LET KEYMAP( CODE "D")=6
LET KEYMAP( CODE "Z")=7
LET KEYMAP( CODE "X")=8
LET KEYMAP( CODE "C")=9
REM positions
' DIM POSITION(20,3): REM (lin, col, card)
REM part 1
LET POSITION(1,1)=0: LET POSITION(1,2)=7
LET POSITION(2,1)=0: LET POSITION(2,2)=13
LET POSITION(3,1)=0: LET POSITION(3,2)=19
REM part 2
LET POSITION(4,1)=8: LET POSITION(4,2)=7
LET POSITION(5,1)=8: LET POSITION(5,2)=13
LET POSITION(6,1)=8: LET POSITION(6,2)=19
REM part 3
LET POSITION(7,1)=16: LET POSITION(7,2)=7
LET POSITION(8,1)=16: LET POSITION(8,2)=13
LET POSITION(9,1)=16: LET POSITION(9,2)=19
' first FirstPlayer
FirstPlayer = 1
FirstPlayer = 3 - FirstPlayer ' fix FirstPlayer number
Score1 = 0
Score2 = 0
END PROCEDURE

PROCEDURE Instructions
BORDER black : PAPER black : INK magenta : CLS
PRINT tab 10; "INSTRUCTIONS"
PRINT
INK green
PRINT "Place your cards on the board."
PRINT "If a place is empty, then you","can place any card from 1 to 6."
PRINT "If a place has a card, then you can place only the successor","card."
PRINT "The first player to play","five 7's wins."
PRINT
PAUSE 1*50
INK yellow
PRINT "Game creator: Jorge Magalhaes"
PRINT "Programmer:   David Magalhaes"
PRINT "Language:     Pascalated BASIC"
PRINT "Compiler:     Boriel ZX BASIC"
PRINT
PAUSE 1*50
INK cyan
PRINT AT 23,0; "Press any key to continue"; FLASH 1; " "
BEEP .05,20
PAUSE 0
END PROCEDURE

PROCEDURE Main
Instructions
InitProgram
REPEAT 
  Game
UNTIL FALSE
END PROCEDURE

BEGIN
REM PRINT "Demo for Pascalated BASIC"
PRINT PAPER green; INK black; AT 23,15;"(c) Starsoft 2023";
BEEP .05,20
PAUSE 50
PAUSE 50
Main
END
